
SENSE_LEN                   equ 14          ; Default sense buffer length
SRB_DIR_IN                  equ 008h        ; Transfer from SCSI target to host
SRB_DIR_OUT                 equ 010h        ; Transfer from host to SCSI target
SRB_EVENT_NOTIFY            equ 040h        ; Enable ASPI event notification

; ASPI Command Definitions

SC_EXEC_SCSI_CMD            equ 002h        ; Execute SCSI command

; SRB Status

SS_PENDING                  equ 000h        ; SRB being processed
SS_COMP                     equ 001h        ; SRB completed without error
SS_ERR                      equ 004h        ; SRB completed with error

; SRB - EXECUTE SCSI COMMAND - SC_EXEC_SCSI_CMD (2)

SRB_ExecSCSICmd struct
	SRB_Cmd         db ?                   ; 00/000 ASPI command code = SC_EXEC_SCSI_CMD
	SRB_Status      db ?                   ; 01/001 ASPI command status byte
	SRB_HaId        db ?                   ; 02/002 ASPI host adapter number
	SRB_Flags       db ?                   ; 03/003 ASPI request flags
	SRB_Hdr_Rsvd    dd ?                   ; 04/004 Reserved
	SRB_Target      db ?                   ; 08/008 Target's SCSI ID
	SRB_Lun         db ?                   ; 09/009 Target's LUN number
	SRB_Rsvd1       dw ?                   ; 0A/010 Reserved for Alignment
	SRB_BufLen      dd ?                   ; 0C/012 Data Allocation Length
	SRB_BufPointer  dd ?                   ; 10/016 Data Buffer Pointer
	SRB_SenseLen    db ?                   ; 14/020 Sense Allocation Length
	SRB_CDBLen      db ?                   ; 15/021 CDB Length
	SRB_HaStat      db ?                   ; 16/022 Host Adapter Status
	SRB_TargStat    db ?                   ; 17/023 Target Status
	SRB_PostProc    dd ?                   ; 18/024 Post routine
	SRB_Rsvd2       db 20 dup (?)          ; 1C/028 Reserved, MUST = 0
	CDBByte         db 16 dup (?)          ; 30/048 SCSI CDB
	SenseArea       db SENSE_LEN+2 dup (?) ; 50/064 Request Sense buffer
SRB_ExecSCSICmd ends

; PROTOTYPES - User Callable ASPI for Win32 Functions

GetASPI32SupportInfo   PROTO C :DWORD
SendASPI32Command      PROTO C :DWORD
GetASPI32Buffer        PROTO C :DWORD
FreeASPI32Buffer       PROTO C :DWORD
TranslateASPI32Address PROTO C :DWORD,:DWORD
